//
//  downLoadPreviewViewController.m
//  隐私保护
//
//  Created by xd h on 2024/1/7.
//

#import "downLoadPreviewViewController.h"
#import "couldPhoneFileListModel.h"
#import "downLoadPreViewCell.h"
#import "downloadFileBottomView.h"
#import "downloadThumbnailManager.h"
#import "downloadManager.h"
#import "uploadFileRecordViewController.h"
#import "UIScrollView+EmptyDataSet.h"

@interface downLoadPreviewViewController ()<UITableViewDelegate,UITableViewDataSource,DZNEmptyDataSetSource, DZNEmptyDataSetDelegate>
@property (nonatomic, strong) UITableView *tableView;
@property (nonatomic, strong) UIButton *rightButton;
@property (nonatomic, strong) downloadFileBottomView *downloadFileBottomV;
@property (nonatomic,assign) BOOL didGetType;

@property(nonatomic,strong) couldPhoneFileListModel *curCouldPhoneFileListMod;
@end

@implementation downLoadPreviewViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    
    [self.toolBar setHidden:YES];
    [self.navigationBar setHidden:YES];
    [self.navBarBGView setHidden:NO];
    self.navBarBGView.backgroundColor = [UIColor whiteColor];
    [self.view setBackgroundColor:[UIColor whiteColor]];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(searchFileListDoneFun:) name:searchFileListDoneNotification object:nil];
    
    [self drawAnyView];
}

- (void)drawAnyView{
    
    _rightButton = [[UIButton alloc] init];
    [_rightButton setTitle:NSLocalizedString(@"File_upload_Record_select_all",nil) forState:UIControlStateNormal];
    [_rightButton setTitle:NSLocalizedString(@"File_upload_cancel_select_all",nil) forState:UIControlStateSelected];
    
    [_rightButton setTitleColor:[UIColor hwColor:@"#01B7EA" alpha:1.0] forState:UIControlStateNormal];
    _rightButton.titleLabel.font = [UIFont systemFontOfSize:18.0];
    _rightButton.contentHorizontalAlignment = UIControlContentHorizontalAlignmentRight;
    [_rightButton addTarget:self action:@selector(didClickSelectAllButton:) forControlEvents:UIControlEventTouchUpInside];
    [self.navBarBGView addSubview:_rightButton];
    
    
    
    [_rightButton mas_makeConstraints:^(MASConstraintMaker *make) {
        make.width.mas_equalTo(120);
        make.height.mas_equalTo(40);
        make.right.mas_equalTo(-15);
        make.centerY.mas_equalTo(self.titleLabel.mas_centerY);
    }];
    
    [self.view addSubview:self.tableView];
    [self.tableView mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(-(60 + safeArea));
        make.top.equalTo(self.navBarBGView.mas_bottom).offset(10.f);
    }];
    
    _downloadFileBottomV = [[downloadFileBottomView alloc] init];
    [self.view insertSubview:_downloadFileBottomV atIndex:0];
    
    [_downloadFileBottomV mas_makeConstraints:^(MASConstraintMaker *make) {
        make.left.mas_equalTo(0);
        make.right.mas_equalTo(0);
        make.bottom.mas_equalTo(0);
        make.height.mas_equalTo(60 + safeArea);
    }];
    
    [self RefreshBottomViewUIFun];
    
    KWeakSelf
    _downloadFileBottomV.didClickDownloadFile = ^{
        [weakSelf gotoDownloadloadFileRecordFun];
    };
    
}

#pragma mark - 懒加载
- (UITableView *)tableView{
    if (!_tableView) {
        _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 0, SCREEN_W, SCREEN_H - TABBARHEIGHT) style:UITableViewStylePlain];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        _tableView.showsVerticalScrollIndicator = NO;
        _tableView.showsHorizontalScrollIndicator = NO;
//        _tableView.contentInset = UIEdgeInsetsMake(-H_STATE_BAR, 0, 0, 0);
        [_tableView setSeparatorStyle:(UITableViewCellSeparatorStyleNone)];
        [_tableView setSeparatorColor:[UIColor clearColor]];
        [_tableView setBackgroundColor:[UIColor clearColor]];
        [_tableView setTableFooterView:[UIView new]];
        [_tableView setBounces:YES];
        
        if (@available(iOS 15.0, *)) {
            _tableView.sectionHeaderTopPadding = 0;
        }
        
        //空数据引入第三方开源处理
        _tableView.emptyDataSetSource = self;
        _tableView.emptyDataSetDelegate = self;
    }
    
    return _tableView;
}


#pragma mark - 列表委托
- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    if(!_curCouldPhoneFileListMod){
        return 0;
    }
    return _curCouldPhoneFileListMod.data.list.count;
}

- (downLoadPreViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    
    __block NSInteger row = indexPath.row;
    static NSString *identifier = @"downLoadPreViewCell";
    
    downLoadPreViewCell * cell =  [tableView dequeueReusableCellWithIdentifier:identifier];
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    if (!cell){
        cell = [[downLoadPreViewCell alloc] initWithStyle:UITableViewCellStyleValue1 reuseIdentifier:identifier];
        [cell setSelectionStyle:UITableViewCellSelectionStyleNone];
        [cell setBackgroundColor:[UIColor clearColor]];
        [cell setAccessoryType:(UITableViewCellAccessoryNone)];
        
        [cell.bgViewLayer removeFromSuperlayer];
        [cell.titleLabel2 setHidden:NO];
        [cell.rightImage setHidden:YES];
        [cell.lineView setHidden:YES];
        [cell.checkButton setHidden:NO];
        
    }
    
    if(row < _curCouldPhoneFileListMod.data.list.count){
        couldPhoneFileModel* fileModel = _curCouldPhoneFileListMod.data.list[row];
        cell.curFileModel = fileModel;
    }
    
    
    KWeakSelf
    cell.didClickSwitch = ^(BOOL SwitchOn) {
        [weakSelf userCheckFilePreviewByRow:row];
    };
    
    return cell;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 70;
}

#pragma mark 空数据
- (UIImage *)imageForEmptyDataSet:(UIScrollView *)scrollView {
    
    NSString *imageName = @"uploadFile_noData";
    
    return [UIImage imageNamed:imageName];
}

- (NSAttributedString *)titleForEmptyDataSet:(UIScrollView *)scrollView {
    NSString *text = NSLocalizedString(@"File_download_file_no_data",nil);
    
    NSDictionary *attributes = @{NSFontAttributeName: [UIFont systemFontOfSize:16.0f],
                                 NSForegroundColorAttributeName: HW999999Color};
    
    return [[NSAttributedString alloc] initWithString:text attributes:attributes];
}

//调整图片位置
- (CGFloat)verticalOffsetForEmptyDataSet:(UIScrollView *)scrollView {
    return -150;
}

- (void)userCheckFilePreviewByRow:(NSInteger)row
{
    if(row < _curCouldPhoneFileListMod.data.list.count){
        couldPhoneFileModel* fileModel = _curCouldPhoneFileListMod.data.list[row];
         fileModel.isSelectType = !fileModel.isSelectType;
        [self.tableView reloadData];
        [self RefreshBottomViewUIFun];
    }
}

- (void)didClickSelectAllButton:(UIButton*)button
{
    button.selected = !button.selected;
    
    for (couldPhoneFileModel* fileModel in _curCouldPhoneFileListMod.data.list) {
        fileModel.isSelectType = button.selected;
    }
    
    [self.tableView reloadData];
    [self RefreshBottomViewUIFun];
}

#pragma mark 刷新底部
- (void)RefreshBottomViewUIFun
{
    NSMutableArray *selectArr = [NSMutableArray new];
    
    for (couldPhoneFileModel* fileModel in _curCouldPhoneFileListMod.data.list) {
        
        if(fileModel.isSelectType){
            [selectArr addObject:fileModel];
        }
    }
    
    _downloadFileBottomV.indexPathsForSelectedItems = selectArr;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
    
    if(!_didGetType){
        if(_isPhotoType){
            self.titleLabel.text = NSLocalizedString(@"my_set_no_image_upload",nil) ;
        }
        else{
            self.titleLabel.text = NSLocalizedString(@"my_set_no_video_upload",nil) ;
        }
        
        [self searchFileListFun];
        
        _didGetType = YES;
    }
    
}

- (void)searchFileListFun
{
    NSNumber *curNum = [NSNumber numberWithBool:_isPhotoType];
    [[NSNotificationCenter defaultCenter] postNotificationName:searchFileListBeginNotification object:curNum];/*发送通知*/
}

- (void)searchFileListDoneFun:(NSNotification*)notification
{
    NSDictionary *dataDict = [notification object];
    
    if(!dataDict || ![dataDict isKindOfClass:[NSDictionary class]]){
        return;
    }
    
    _curCouldPhoneFileListMod = [[couldPhoneFileListModel alloc] initWithDictionary:dataDict error:nil];
    
    [self.tableView reloadData];
    
    [self gotoDownThumbnailManagerFun];
}


#pragma mark 去下载缩略图
- (void)gotoDownThumbnailManagerFun
{
    [[downloadThumbnailManager shareInstance] handlToDownloadThumbnailWith:_curCouldPhoneFileListMod.data.list];
}

- (void)gotoDownloadloadFileRecordFun
{
    uploadFileRecordViewController *vc = [uploadFileRecordViewController new];
    [self.navigationController pushViewController:vc animated:YES];
    vc.isDownloadingType = YES;
    [vc gotoDownloadFile:_downloadFileBottomV.indexPathsForSelectedItems];
}

@end
