//
//  downloadManager.m
//  隐私保护
//
//  Created by xd h on 2024/1/9.
//

#import "downloadManager.h"
#import "cachesFileManager.h"

@implementation downloadManager
static downloadManager * cur_downloadManager = nil;
+(downloadManager *)shareInstance;
{
    static dispatch_once_t onceToken;
    
    dispatch_once(&onceToken, ^{
        cur_downloadManager = [[downloadManager alloc] init];
        
    });
    
    return cur_downloadManager;
}

- (id)init
{
    self = [super init];
    
    if (self) {
        //[self initManager];
    }
    
    return self;
}


#pragma mark 读取数据库数据
- (void)getDataInDatabaseFun:(BOOL)isReGet complete:(custom_complete_Arr)complete
{
    if(_databaseArr && _databaseArr.count == 3 && !isReGet){
        complete(_databaseArr);
        return;
    }
    
    if(!_databaseArr)
    {
        _databaseArr = [NSMutableArray new];
    }
    
    //KWeakSelf
    //dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT,0), ^{
        [couldPhoneFileModel bg_findAsync:download_tableName limit:0 orderBy:nil desc:NO complete:^(NSArray * _Nullable array) {
            NSMutableArray *failArr = [NSMutableArray new];
            NSMutableArray *doneArr = [NSMutableArray new];
            NSMutableArray *otherArr = [NSMutableArray new];
            
                for (couldPhoneFileModel * curModel in array) {
                
                    if(curModel.curDownloadStateType == downloadStateFail){
                        [failArr addObject:curModel];
                    }
                    else if(curModel.curDownloadStateType == downloadStateDone){
                        [doneArr addObject:curModel];
                    }
                    else{
                        [otherArr addObject:curModel];
                    }
                }
            
            NSLock *lock = [NSLock new];
            [lock lock];
            
            NSMutableArray *newArr = [NSMutableArray new];
            [newArr addObject:otherArr];
            [newArr addObject:doneArr];
            [newArr addObject:failArr];
            self->_databaseArr = newArr;
            
            [lock unlock];
            
            complete(self->_databaseArr);
        }];
    //});

}

-(void)handleCouldPhoneFileModelToDownloadFileDataFunBy:(NSMutableArray*)indexPathsForSelectedItems complete:(custom_complete_Arr)complete
{
    if(!indexPathsForSelectedItems && indexPathsForSelectedItems.count == 0){
        complete(nil);
        return;
    }
    
    for (couldPhoneFileModel*model in indexPathsForSelectedItems) {
        model.bg_tableName = download_tableName;
    }
    
    KWeakSelf
    //查
    [self getDataInDatabaseFun:YES complete:^(NSMutableArray * _Nonnull Arr) {
        //排重
        NSMutableArray *newDownArr = [weakSelf  checkDownloadTaskRepeatFun:indexPathsForSelectedItems];
        
        if(newDownArr.count>0){
            //存
            [couldPhoneFileModel bg_saveOrUpdateArrayAsync:newDownArr complete:^(BOOL isSuccess) {
                //再查
                [weakSelf getDataInDatabaseFun:YES complete:^(NSMutableArray * _Nonnull Arr) {
                    complete(Arr);
                    [weakSelf planToDownloadFileFun];
                }];
            }];
        }
        else{
            complete(Arr);
            [weakSelf planToDownloadFileFun];
        }
        
    }];
}

#pragma mark 检测是否有下载任务重复
- (NSMutableArray*)checkDownloadTaskRepeatFun:(NSMutableArray*)indexPathsForSelectedItems
{
    if(!_databaseArr || _databaseArr.count != 3){
        return indexPathsForSelectedItems;
    }
    
    NSMutableArray *downloadArr = _databaseArr[0];
    NSMutableArray *newTaskArr = [NSMutableArray new];
    
    for (couldPhoneFileModel*model in indexPathsForSelectedItems) {
       NSString *fileName = [model getFileNameFun];
        
        BOOL isNeedAddType = YES;
        for (couldPhoneFileModel* hadModel in downloadArr) {
            NSString *hadFileName = [hadModel getFileNameFun];
            if([fileName isEqualToString:hadFileName]){
                isNeedAddType = NO;
                break;
            }
        }
        
        if(isNeedAddType){
            [newTaskArr addObject:model];
        }
    }
    
    return newTaskArr;
}

- (void)planToDownloadFileFun
{
    if(!_databaseArr || _databaseArr.count != 3){
        return;
    }
    
    _downLoadFileModelDataArr = _databaseArr[0];
    
    [self beginDownloadFileFun];
}

- (void)beginDownloadFileFun
{
    if(_downLoadFileModelDataArr.count == 0)
    {
        return;
    }
    
    _isSuspendType = NO;
    _isDownloadIngType = YES;
    
    if(_reDownloadIngSelectIndex > 0
       && _reDownloadIngSelectIndex < _downLoadFileModelDataArr.count){
        _curDownloadFileModel = _downLoadFileModelDataArr[_reDownloadIngSelectIndex];
    }
    else
    {
        _curDownloadFileModel = _downLoadFileModelDataArr.firstObject;
    }
    
    
    if(!_curDownloadFileModel){
        return;
    }
    
    _curDownloadFileModel.curDownloadStateType = downloadStateUploading;
    
    [[NSNotificationCenter defaultCenter] postNotificationName:downloadFileBeginNotification object:_curDownloadFileModel];
}

- (void)DownloadFileDoneOneFileFun
{
    _curDownloadFileModel.curDownloadStateType = downloadStateDone;
//    NSString *fileName = [_curDownloadFileModel getFileNameFun];
//    [cachesFileManager removeItemAtPath:fileName type:DownLoadFileType error:nil];
    
   
    [self DownloadFileChangeingOneFileFun];
    
    if(_isSuspendType){
        return;
    }
    [self beginDownloadFileFun];
}

- (void)DownloadFileChangeingOneFileFun
{
    if(_curDownloadFileModel.curDownloadStateType == downloadStateDone){
        [_downLoadFileModelDataArr removeObject:_curDownloadFileModel];
        [self handleDatabaseArrAddObjectInDone:_curDownloadFileModel];
    }
    else if(_curDownloadFileModel.curDownloadStateType == uploadStateFail){
        [self handleDatabaseArrDeleteObjectInDownloading:_curDownloadFileModel];
        [self handleDatabaseArrAddObjectInFail:_curDownloadFileModel];
    }

    [_curDownloadFileModel bg_saveOrUpdateAsync:^(BOOL isSuccess) {
        //HLog(@"%@ 写入 %@", model.filename, isSuccess ? @"成功":@"失败");
    }];
        
    
    if(!_isSuspendType || _curDownloadFileModel.curDownloadStateType != uploadStateSuspend){
        [[NSNotificationCenter defaultCenter] postNotificationName:downloadFileRefreshNotification object:_curDownloadFileModel];
    }
    
}



- (void)handleDatabaseArrDeleteObjectInDownloading:(couldPhoneFileModel*)model
{
    if(_databaseArr && _databaseArr.count == 3 ){
        NSMutableArray *ingArr = _databaseArr[0];
        [ingArr removeObject:model];
    }
}

- (void)handleDatabaseArrAddObjectInDone:(couldPhoneFileModel*)model
{
    if(_databaseArr && _databaseArr.count == 3 ){
        NSMutableArray *doneArr = _databaseArr[1];
        [doneArr insertObject:model atIndex:0];
    }
}

- (void)handleDatabaseArrAddObjectInFail:(couldPhoneFileModel*)model
{
    if(_databaseArr && _databaseArr.count == 3 ){
        NSMutableArray *failArr = _databaseArr[2];
        [failArr insertObject:model atIndex:0];
    }
}

- (void)suspendDownloadFileFun:(BOOL)isSuspendAll
{
    _isSuspendType = YES;
    
    if(isSuspendAll){
        for (couldPhoneFileModel *couldPhoneFileMod in _downLoadFileModelDataArr) {
            couldPhoneFileMod.curDownloadStateType = downloadStateSuspend;
        }
    }
}

- (void)reDownloadFileFunBy:(NSMutableArray*)Arr
{
    if(!_downLoadFileModelDataArr){
        _downLoadFileModelDataArr = [NSMutableArray new];
    }
    
    _reDownloadIngSelectIndex = 0;
    
    for (uploadFileDataModel*addModel in Arr) {
        
        BOOL needAddModel = YES;
        
        for (int i=0;i< _downLoadFileModelDataArr.count;i++)
        {
            couldPhoneFileModel*preModel = _downLoadFileModelDataArr[i];
            
            if(addModel.bg_id.integerValue == preModel.bg_id.integerValue)
            {
                needAddModel = NO;
                
                if(_reDownloadIngSelectIndex == 0){
                    _reDownloadIngSelectIndex = i;
                    
                    if(i==0){
                        _reDownloadIngSelectIndex = -1;
                    }
                }
                
                break;
            }
        }
        
        if(needAddModel){
            [_downLoadFileModelDataArr addObject:addModel];
            _reDownloadIngSelectIndex = _downLoadFileModelDataArr.count -1;
        }
    }
    
    [self beginDownloadFileFun];
}

- (void)handleDatabaseArrByDelete:(couldPhoneFileModel*)delModel
{
    if(_databaseArr && _databaseArr.count == 3 ){
        
        if(delModel.curDownloadStateType == downloadStateDone)
        {
            NSMutableArray *arr = _databaseArr[1];
            [arr removeObject:delModel];
        }
        else if(delModel.curDownloadStateType == downloadStateFail){
            NSMutableArray *arr = _databaseArr[2];
            [arr removeObject:delModel];
        }
        else{
            NSMutableArray *arr = _databaseArr[0];
            [arr removeObject:delModel];
        }
    }
}


- (void)deleteDownloadFileRecordBy:(NSMutableArray *)delArr withDelCache:(BOOL)isDelCache
{
    //逻辑待优化
    BOOL isSuc = false;
    
    BOOL isDelUploadingModel = false;
    
    NSMutableArray *curDelArr = [NSMutableArray arrayWithArray:delArr];
    for (couldPhoneFileModel *couldPhoneFileMod in curDelArr) {
        
        NSMutableString* where = [[NSMutableString alloc] initWithString:@"where "];
        
        NSString *curStr =  [NSString stringWithFormat:@"%@=%@ ",bg_sqlKey(@"bg_id"),bg_sqlValue(couldPhoneFileMod.bg_id)];
        [where appendString:curStr];
        
        [couldPhoneFileModel bg_deleteAsync:download_tableName where:where complete:^(BOOL isSuccess) {
        }];
       
       //isSuc =  [couldPhoneFileModel bg_delete:download_tableName where:where];
        
        [self handleDatabaseArrByDelete:couldPhoneFileMod];
        
        if(couldPhoneFileMod.bg_id.integerValue == _curDownloadFileModel.bg_id.integerValue){
            isDelUploadingModel = YES;
            [self suspendDownloadFileFun:NO];
        }

    }
    
    if(isDelUploadingModel){
        _isDownloadIngType = NO;
        if(_downLoadFileModelDataArr > 0){
            [self beginDownloadFileFun];
        }
    }
    
    [[NSNotificationCenter defaultCenter] postNotificationName:downloadFileRefreshNotification object:_curDownloadFileModel];
    
}
@end
